using FluentResults;

namespace PkmnLib.Dynamic.ScriptHandling;

public interface IScriptSet : IEnumerable<ScriptContainer>
{
    Result<ScriptContainer> Add(Script script);
    Result<ScriptContainer?> Add(string scriptKey);
    ScriptContainer? Get(string scriptKey);
    void Remove(string scriptKey);
    void Clear();
    void Contains(string scriptKey);
    ScriptContainer At(int index);
    int Count { get; }
    IEnumerable<string> GetScriptNames();
}